package net.xinhuamm.xycloud.xinhuamm_xycloud

import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import androidx.fragment.app.FragmentActivity
import io.flutter.plugin.platform.PlatformView

/**
 * author : yuntong
 * date   : 2023/11/17 14:32
 * desc   :
 */
class XYCloudWebView(
    val context: FragmentActivity,
    val viewId: Int,
    val args: Any?
) : PlatformView {

    private var fragment: XYCloudFragment? = null

    override fun getView(): View {
        val view = FrameLayout(context)
        val vParams: ViewGroup.LayoutParams = FrameLayout.LayoutParams(
            ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT
        )
        view.layoutParams = vParams
        view.id = R.id.xinhuamm_xycloud_id_container
        if (args is Map<*, *>) {
            val urlValue = args["url"]
            if (urlValue is String) {
                val url: String = urlValue
                fragment = XYCloudFragment.newInstance(url)
                val fm = context.supportFragmentManager
                fm.beginTransaction()
                    .replace(view.id, fragment!!)
                    .commitAllowingStateLoss()
                XYCloudManager.setNotifyVisibility {
                    if (it) {
                        fragment?.onResume()
                    } else {
                        fragment?.onPause()
                    }
                }
            } else {
                view.addView(XYCloudErrorView(context, args).view)
            }
        } else {
            view.addView(XYCloudErrorView(context, args).view)
        }
        return view
    }

    override fun dispose() {
        fragment?.onDestroy()
    }
}